<template>
  <div class="relative">
    <input
      id="inputBlock"
      v-model="search"
      :placeholder="searchText"
      class="border border-black rounded-lg border-bkt-fakeblack-grey-focus w-full"
      @input="update"
      @focusin="FocusIn"
    >

    <v-menu activator="parent" :close-on-content-click="false">
      <template #default>
        <div class="w-full absolute z-[100] overflow-visible">
          <slot name="dropdown" />

          <slot name="dropdown-additional" :search="search" />
        </div>
      </template>
    </v-menu>

    <v-btn
      v-if="search.length"
      class="svg-right bg-transparent"
      variant="text"
      height="50"
      width="50"
      @click="clear"
    >
      <Icon
        class="text-dark-grey"
        icon="mdi:multiply"
        width="24"
        height="24"
      />
    </v-btn>
  </div>
</template>

<script setup>
import { ref } from "vue";
import { Icon } from "@iconify/vue";

const emit = defineEmits(['input', 'click'])

const props = defineProps({
  value: { type: String, default: null },
  users: { type: Array, default: () => [] },
  searchText: { type: String, default: 'Search' },
  persistent: { type: Boolean, default: false },
})

const search = ref('')
const searchListDisplay = ref(false)

let timer = null

const update = (e) => {
  if (timer) clearTimeout(timer)

  timer = setTimeout(() => {
    emit('input', e?.target?.value || '')
  }, 300)
}

const hide = () => {
  searchListDisplay.value = false;
};

const clear = () => {
  search.value = ""
  hide()
}

const FocusIn = () => {
  update('')
  searchListDisplay.value = true
}
</script>

<style scoped>
input {
  padding-right: 70px !important;
  padding-left: 15px !important;
  height: 50px;
}

.svg-right {
  position: absolute;
  top: 10px;
  right: 10px;
}

.svg-left {
  position: absolute;
  top: 10px;
  left: 10px;
}
</style>
